## python-pyppmd 1.1.0+ds

=== debian/changelog ===
python-pyppmd (1.1.0+ds-4) unstable; urgency=medium

  * Force to use CFFI for multi-platform compatibility
  * Update cpuinfo module patch

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 30 Jun 2024 00:42:22 +0900

python-pyppmd (1.1.0+ds-3) unstable; urgency=medium

  * Disable flaky fuzzing test
    Fuzzing test sometimes hangups test.
  * patch: Initialize values
    (debian/patches/0003-Initialize-values.patch)
    "buffer" is uninitialized when PyArg_ParseTupleAndKeywords() returned
    error.
  * patch: Skip benchmark tests if cpuinfo module is not supported
    (debian/patches/0004-Skip-benchmark-tests-if-cpuinfo-module-is-not-
    suppor.patch)
    "cpuinfo" modules dose not supports minor platforms.
    This patch skips benchmark tests on those platforms.

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Thu, 02 May 2024 10:06:06 +0900

python-pyppmd (1.1.0+ds-2) unstable; urgency=medium

  * Packaging update
  * patch: Use stdint.h and stdbool.h to determine storage size of each
    data types
    (debian/patches/0001-Use-stdint.h-and-stdbool.h-to-determine-storage-size.patch)
    Upstream code uses architecture name to determin platform register size
    (32/64 bits). But this method is insufficient for minor platforms like
    non-x86/non-ARM platforms.
    This patch uses <stdint.h> and <stdbool.h> to determin correct register
    size even in minor platforms.
  * Standards-Version: 4.7.0 (routine-update)
  * Testsuite: autopkgtest-pkg-pybuild (routine-update)
  * No tab in license text (routine-update)
  * Upgrade Python build sequencer
  * Upgrade Python test sequencer
  * patch: FTBFS fix for Hurd
    (debian/patches/0002-FTBFS-fix-for-Hurd.patch)
    Use "__APPLE__" instead of "__MACH__" if the code is only for macOS.

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Apr 2024 12:32:48 +0900

python-pyppmd (1.1.0+ds-1) unstable; urgency=medium

  * Initial commit (Closes: #1068315)

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 07 Apr 2024 05:57:50 +0900

## python-pyppmd 1.1.1%2Bds

=== debian/watch ===
version=4
opts="uversionmangle=s/(rc|a|b|c)/~$1/, \
      dversionmangle=s/\+ds//, \
      oversionmangle=s/$/+ds/" \
https://pypi.debian.net/pyppmd/pyppmd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## python-pyppmd 1.2.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(pyppmd C CXX)

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

# TARGET PYTHON version
set(PY_VERSION 3.12)
set(Python_FIND_IMPLEMENTATIONS CPython)
#set(Python_FIND_IMPLEMENTATIONS PyPy)
set(VENV_PATH "${CMAKE_BINARY_DIR}/venv")
set(DEBUG_BUILD ON)

# ##################################################################################################
# Configuration for python-ext
set(Python_FIND_STRATEGY VERSION)
find_package(Python ${PY_VERSION}.0...${PY_VERSION}.99 COMPONENTS Interpreter Development)
set(PY_EXT_FILE _ppmd)
set(PY_CFFI_FILE _cffi_ppmd)
set(PY_EXT_DIR pyppmd/c)
set(PY_CFFI_DIR pyppmd/cffi)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/get_ext.py
     "import sysconfig\nprint(sysconfig.get_config_var('EXT_SUFFIX'))\n")
execute_process(
  COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/get_ext.py
  OUTPUT_VARIABLE PY_EXT_EXT
  OUTPUT_STRIP_TRAILING_WHITESPACE)

set(PY_BUILD_LIB_DIR build/lib.${PY_PLATFORM}-${Python_VERSION_MAJOR}.${Python_VERSION_MINOR})
set(PY_EXT_INPLACE src/${PY_EXT_DIR}/${PY_EXT_FILE}.${PY_EXT_EXT})
set(PY_EXT ${PY_BUILD_LIB_DIR}/${PY_EXT_DIR}/${PY_EXT_FILE}.${PY_EXT_EXT})
set(PY_CFFI_INPLACE src/${PY_CFFI_DIR}/${PY_CFFI_FILE}.${PY_EXT_EXT})
set(PY_CFFI ${PY_BUILD_LIB_DIR}/${PY_CFFI_DIR}/${PY_CFFI_FILE}.${PY_EXT_EXT})
if (WIN32)
  if(DEBUG_BUILD)
    set(BUILD_EXT_PYTHON ${VENV_PATH}/Scripts/python_d.exe)
  else()
    set(BUILD_EXT_PYTHON ${VENV_PATH}/bin/python.exe)
  endif()
  set(BUILD_EXT_OPTION -g)
else()
    set(BUILD_EXT_PYTHON ${VENV_PATH}/bin/python)
    set(BUILD_EXT_OPTION -g)
endif()
add_custom_target(
  generate_ext
  BYPRODUCTS ${PY_EXT}
  COMMAND ${BUILD_EXT_PYTHON} setup.py build_ext ${BUILD_EXT_OPTION}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS venv.stamp
  SOURCES ${pyppmd_sources})
add_custom_target(
  generate_cffi
  BYPRODUCTS ${PY_CFFI_INPLACE}
  COMMAND ${BUILD_EXT_PYTHON} setup.py build_ext ${BUILD_EXT_OPTION} --cffi --inplace
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS venv.stamp
  SOURCES ${pyppmd_sources})

# ##################################################################################################
include_directories(src/lib/buffer src/lib/ppmd)
set(_sources src/ext/_ppmdmodule.c src/lib/buffer/Buffer.c src/lib/buffer/ThreadDecoder.c
        src/lib/ppmd/Ppmd7.c src/lib/ppmd/Ppmd7Dec.c src/lib/ppmd/Ppmd7Enc.c
        src/lib/ppmd/Ppmd8.c src/lib/ppmd/Ppmd8Dec.c src/lib/ppmd/Ppmd8Enc.c)
Python_add_library(_ppmd MODULE WITH_SOABI ${_sources})
add_custom_target(build_ext
        BYPRODUCTS ${PY_EXT_INPLACE}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different $<TARGET_FILE:_ppmd> ${CMAKE_SOURCE_DIR}/src/${PY_EXT_DIR}
        DEPENDS _ppmd venv.stamp
        )

# ##################################################################################################
# create virtualenv
file(
        WRITE ${CMAKE_CURRENT_BINARY_DIR}/requirements.txt
        "
coverage[toml]>=5.2
hypothesis
pytest>=6.0
pytest-benchmark
pytest-cov
pytest-timeout
cffi
py-cpuinfo
tox
")
if (WIN32)
  set(PIP_COMMAND ${VENV_PATH}/Scripts/pip.exe)
else()
  set(PIP_COMMAND ${VENV_PATH}/bin/pip)
endif()
add_custom_command(OUTPUT venv.stamp
        COMMAND ${Python_EXECUTABLE} -m venv ${VENV_PATH}
        COMMAND ${PIP_COMMAND} install -r ${CMAKE_BINARY_DIR}/requirements.txt
        COMMAND ${CMAKE_COMMAND} -E touch venv.stamp)
set(SRC_PATH "${CMAKE_SOURCE_DIR}/src")
if ("${Python_INTERPRETER_ID}" STREQUAL "PyPy")
  set(VPKG_PATH_A "${VENV_PATH}/lib/pypy${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")
else()
  set(VPKG_PATH_A "${VENV_PATH}/lib/python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")
endif()
set(VPKG_PATH_B "${VENV_PATH}/Lib/site-packages/")

# ##################################################################################################
# For pytest
file(
  WRITE ${CMAKE_CURRENT_BINARY_DIR}/pytest_runner.cpp
  "
#include <string>
#include <filesystem>
#include <unistd.h>
int main(int argc, char **argv) {
    std::string args;
    if ( argc > 1) {
        args.append(\"[\");
        for (int i = 1; i < argc; i++) {
            if (i > 2)
                args.append(\",\");
            args.append(\"\\\"\");
            args.append(argv[i]);
            args.append(\"\\\"\");
        }
        args.append(\"]\");
    }
    std::filesystem::path src_path = \"${SRC_PATH}\";
    std::filesystem::path vsite_path_a = \"${VPKG_PATH_A}\";
    std::filesystem::path vsite_path_b = \"${VPKG_PATH_B}\";
    std::string pycode =
        \"import sys\\n\"
        \"sys.path.append('\" + src_path.string() + \"')\\n\"
        \"sys.path.append('\" + vsite_path_a.string() + \"')\\n\"
        \"sys.path.append('\" + vsite_path_b.string() + \"')\\n\"
        \"import pytest\\n\"
        \"pytest.main(\" + args + \")\\n\";
    execl(\"${Python_EXECUTABLE}\", \"${Python_EXECUTABLE}\", \"-c\", pycode.c_str(), (char*)0);
    return 0;
}")
add_executable(pytest_runner ${CMAKE_CURRENT_BINARY_DIR}/pytest_runner.cpp)
if ("${Python_INTERPRETER_ID}" STREQUAL "PyPy")
  add_dependencies(pytest_runner generate_cffi)
else()
  add_dependencies(pytest_runner generate_ext build_ext)
endif()
target_include_directories(pytest_runner PRIVATE ${Python_INCLUDE_DIRS})
target_link_libraries(pytest_runner PRIVATE ${Python_LIBRARIES})
add_custom_target(run_pytest
        COMMAND $<TARGET_FILE:pytest_runner> --verbose
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        DEPENDS pytest_runner)

# ##################################################################################################
# for build test and analytics
include_directories(src/lib/ppmd src/lib/buffer)
add_library(
        pyppmd
        src/lib/ppmd/Arch.h
        src/lib/ppmd/Interface.h
        src/lib/ppmd/Ppmd.h
        src/lib/ppmd/Ppmd7.c
        src/lib/ppmd/Ppmd7.h
        src/lib/ppmd/Ppmd7Dec.c
        src/lib/ppmd/Ppmd7Enc.c
        src/lib/ppmd/Ppmd8.c
        src/lib/ppmd/Ppmd8.h
        src/lib/ppmd/Ppmd8Dec.c
        src/lib/ppmd/Ppmd8Enc.c
        src/lib/buffer/blockoutput.h
        src/lib/buffer/Buffer.c
        src/lib/buffer/Buffer.h
        src/lib/buffer/win_pthreads.h
        src/lib/buffer/ThreadDecoder.c
        src/lib/buffer/ThreadDecoder.h
        src/ext/_ppmdmodule.c)
target_include_directories(pyppmd PRIVATE ${Python_INCLUDE_DIRS})
target_link_libraries(pyppmd PRIVATE ${Python_LIBRARIES})
# ##################################################################################################
add_custom_target(run_tox
        COMMAND  ${CMAKE_COMMAND} -E env VIRTUAL_ENV=${VENV_PATH} ${VENV_PATH}/bin/python -m tox
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS venv.stamp
        )

=== utils/requirements.txt ===
PyGithub
tabulate

## python-pyppmd 1.1.1+ds

=== debian/changelog ===
python-pyppmd (1.1.1+ds-1) unstable; urgency=medium

  * New upstream version 1.1.1+ds
  * Rediff patches
  * Renumber patches

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sat, 28 Dec 2024 03:34:44 +0900

=== debian/control ===
Source: python-pyppmd
Section: python
Testsuite: autopkgtest-pkg-pybuild
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
Standards-Version: 4.7.0
Homepage: https://codeberg.org/miurahr/pyppmd
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
  python3-all-dev,
  python3-cffi,
  python3-setuptools,
  python3-setuptools-scm,
  python3-build,
  python3-pytest,
  python3-hypothesis,
  python3-pytest-benchmark,
  python3-pytest-cov,
  python3-pytest-timeout
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-pyppmd
Vcs-Git: https://salsa.debian.org/python-team/packages/python-pyppmd.git

Package: python3-pyppmd
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: PPM (Prediction by partial matching) compression algorithm for Python
 pyppmd module provides classes and functions for compressing and decompressing
 text data, using PPM(Prediction by partial matching) compression algorithm
 which has several variations of implementations. PPMd is the implementation by
 Dmitry Shkarin. PyPPMD use Igor Pavlov's range coder introduced in 7-zip.

## python-pyppmd 1.2.0%2Bds

=== debian/changelog ===
python-pyppmd (1.2.0+ds-2) unstable; urgency=medium

  * Use V5 format for watch file
  * Use local file for salsa CI
  * Drop Emacs mode line from debian/watch

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Sep 2025 14:46:08 +0900

python-pyppmd (1.2.0+ds-1) unstable; urgency=medium

  * Upgrade Debian policy to 4.7.2
  * New upstream version 1.2.0+ds

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Wed, 07 May 2025 03:12:06 +0900

## python-pyppmd 1.2.0+ds

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://codeberg.org/miurahr/pyppmd
 Rules-Requires-Root: no
 Build-Depends:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=pyppmd

# fuzzing tests fails with timeout often
export PYBUILD_TEST_ARGS = -k "not test_ppmd7_fuzzer and \
                               not test_ppmd8_fuzzer"

%:
	dh $@ --buildsystem=pybuild

=== debian/watch ===
Version: 5

Source: https://pypi.debian.net/pyppmd/
Matching-Pattern: pyppmd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
Uversion-Mangle: s/(rc|a|b|c)/~$1/
Dversion-Mangle: s/\+ds//
Oversion-Mangle: s/$/+ds/

## python-pyppmd 1.3.1+ds

=== debian/changelog ===
python-pyppmd (1.3.1+ds-1) unstable; urgency=medium

  * New upstream version 1.3.1+ds
  * Rediff patches

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 30 Nov 2025 21:24:40 +0900

python-pyppmd (1.2.0+ds-6) unstable; urgency=medium

  * Add architecture macro for build rule

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 25 Nov 2025 01:07:55 +0900

python-pyppmd (1.2.0+ds-5) unstable; urgency=medium

  * Disable some tests that requires large memory
  * Display test name for debugging

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 23:39:51 +0900

python-pyppmd (1.2.0+ds-4) unstable; urgency=medium

  * Refactor test arguments
  * Add architecture specific test options

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 11:20:51 +0900

python-pyppmd (1.2.0+ds-3) unstable; urgency=medium

  * Benchmark test is not reliable for ports architecture
  * Make benchmark test as optional one
  * Disable fragile test on ports platforms
  * Update benchmark code
  * "benchmark" marker requires benchmark plugin for any platforms
  * Lintian fix: redundant-rules-requires-root-no-field

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 08:46:47 +0900

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
 Standards-Version: 4.7.2
 Homepage: https://codeberg.org/miurahr/pyppmd
-Rules-Requires-Root: no
 Build-Depends:
   debhelper-compat (= 13),
   dh-sequence-python3,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=pyppmd

PYBUILD_TEST_ARGS =
DISABLE_TESTS =

# Display each test name
PYBUILD_TEST_ARGS += --verbose

# fuzzing tests fails with timeout often
DISABLE_TESTS +=     not test_ppmd7_fuzzer
DISABLE_TESTS += and not test_ppmd8_fuzzer

# disable some tests that requires large memory
ifeq (sparc64,$(DEB_HOST_ARCH))
  DISABLE_TESTS += and not test_ppmd7_encode_decode
  DISABLE_TESTS += and not test_ppmd8_encode_decode
endif

PYBUILD_TEST_ARGS += -k "$(DISABLE_TESTS)"

# Drop benchmark test for ports architecture.
# Because "cpuinfo" module is not reliable for ports architecture.
ifeq (,$(findstring $(DEB_HOST_ARCH),amd64 arm64 armhf i386 ppc64el riscv64 s390x))
  PYBUILD_TEST_ARGS += -m "not benchmark"
endif

export PYBUILD_TEST_ARGS

%:
	dh $@ --buildsystem=pybuild
